#include <iostream>
#include <queue>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

struct man {
    int number;
    int t;
    char dir;
    int ans;
};

int main() {
    int n;
    cin >> n;
    vector<man> t(0);
    for (int i = 0; i < n; ++i) {
        char c;
        int tt;
        cin >> tt >> c;
        t.push_back({i, tt, c});
    }
    int y = 0;
    int globaltime = 0;
    bool paradox = false;
    vector<queue<int>> queues(4);
    map<char, int> m;
    m['U'] = 0;
    m['L'] = 1;
    m['D'] = 2;
    m['R'] = 3;
    vector<int> answer(n, -1);
    queue<int> q;
    while ((y < n && !paradox) || ((!queues[0].empty() || !queues[1].empty() || !queues[2].empty() || !queues[3].empty()) && !paradox)) {
        bool changegt = true;
        for (int i = 0; i < 4; ++i) {
            changegt = (changegt && queues[i].empty());
            //cout << "changegt = " << changegt << " and " << queues[i].empty() << endl;
        }
        if (changegt) {
            //cout << "time warp\n";
            globaltime = t[y].t;
        } else {
            ++globaltime;
        }
        while (t[y].t == globaltime) {
                //cout << "man " << y << " input at " << globaltime << endl;
            queues[m[t[y].dir]].push(t[y].number);
            ++y;
        }
        bool change = false;
        vector<bool> removee(4, false);
        for (int i = 0; i < 4; ++i) {
            if (!queues[i].empty() &&
                    queues[(m[t[queues[i].front()].dir] + 1) % 4].empty()) {
                //cout << "man " << t[queues[i].front()].number << " go out at " << globaltime << endl;
                answer[t[queues[i].front()].number] = globaltime;
                removee[i] = true;
            }
        }
        for (int i = 0; i < 4; ++i) {
            if (removee[i]) {
                queues[i].pop();
                change = true;
            }
        }
        paradox = (!queues[0].empty() && !queues[1].empty() && !queues[2].empty() && !queues[3].empty());
        //char h;
        //cin >> h;
    }
    for (int i = 0; i < n; ++i) {
        cout << answer[i] << endl;
    }
    return 0;
}

/*
4
0 R
0 U
0 L
5 D

7
0 U
0 D
1 L
1 D
2 D
2 R
2 U
*/
