#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 5010;

const ll mod = 3 + 1e9;
const ll p = 239;

ll st[maxN];
ll h1[maxN];
ll h2[maxN];

void build(ll* h, string& s)
{
    h[0] = 0;
    for(int i = 1; i <= s.size(); i++)
    {
        h[i] = (h[i-1] * p + s[i-1])%mod;
    }
}

ll get(ll* h, int l, int r)
{
    return (h[r] - h[l]*st[r-l]%mod + mod)%mod;
}

int dp[maxN];

int main()
{
    //freopen("in.in", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    st[0] = 1;
    for(int i = 1; i <= n + 5; i++) st[i] = (st[i-1] * p)%mod;

    string s, t;
    cin >> s >> t;

    build(h1, s);
    build(h2, t);

    dp[0] = 1;
    for(int i = 1; i <= n; i++)
    {
        for(int k = 1; k <= i && !dp[i]; k++)
        {
            if(get(h2, i - k, i) == get(h1, n - i, n - i + k) && dp[i - k]) dp[i] = 1;
        }
    }

    cout << (dp[n] ? "Yes" : "No") << endl;

    return 0;
}
