import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class D {
	public int len(long n) {
		return (n + "").length();
	}
	
    public void solve() throws IOException {
        long n = nextLong();
        long k = n / 10;
        long ans = k + 1;
        if (n % 10 != 0 && n != 1) {
        	ans += len(n);
        }
        if (k != 0) {
        	int l = len(k);
        	for (int i = 1; i < l; i++) {
        		ans += 9 * tenPow(i - 1) * i;
        	}
        	ans += l * (k - tenPow(l - 1) + 1);
        }
        out.print(ans);
    }
	
	public int tenPow(int k) {
		if (k == 0) {
			return 1;
		}
		return 10 * tenPow(k - 1);
	}

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}
