#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void print(vector<auto> tp)
{
    for (auto i : tp)
        cout << i << " ";
    cout << endl;
}

int main()
{
    //freopen("test.in", "r", stdin);
    ll n;
    cin >> n;
    vector<int> ans(n, -1);
    map<char, int> q;
    q['R'] = 0;
    q['U'] = 1;
    q['L'] = 2;
    q['D'] = 3;
    vector<pair<int, int> > actions(n);
    char a;
    int b;
    for (int i = 0; i < n; ++i)
    {
        cin >> b >> a;
        actions[i] = make_pair(b, q[a]);
    }
    //for (int i = 0; i < n; ++i)
    //    cout << actions[i].first << " " << actions[i].second << endl;
    //cout << endl;
    vector<queue<int> > road(4);
    int t = 0;
    int c_time = actions[0].first;
    while (c_time != actions[n - 1].first)
    {
        while (t < n && actions[t].first == c_time)
        {
            road[actions[t].second].push(t);
            ++t;
        }
        vector<int> to_kick;
        for (int i = 0; i < 4; ++i)
        {
            if (road[(i + 1) % 4].empty() && !road[i].empty())
                to_kick.push_back(i);
        }
        for (int i = 0; i < to_kick.size(); ++i)
        {
            ans[road[to_kick[i]].front()] = c_time;
            road[to_kick[i]].pop();
        }
        c_time ++;
    }
    while (t < n && actions[t].first == c_time)
    {
        road[actions[t].second].push(t);
        //cerr << t << " ";
        ++t;
    }
    //cerr << endl << endl;
    while(true)
    {
        vector<int> to_kick;
        for (int i = 0; i < 4; ++i)
        {
            //cout << i << ": " << road[i].size() << " " << (i + 1) % 4 << ": " << road[(i + 1) % 4].size() << endl;
            if ((road[(i + 1) % 4].empty()) && !road[i].empty())
                to_kick.push_back(i);
        }
        //cout << endl;
        //print(to_kick);
        if (to_kick.empty())
            break;
        for (int i = 0; i < to_kick.size(); ++i)
        {
            ans[road[to_kick[i]].front()] = c_time;
            road[to_kick[i]].pop();
        }
        c_time++;
    }
    for (int i = 0; i < n; ++i)
        cout << ans[i] << endl;
    return 0;
}
