#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <queue>

using namespace std;

struct machine{
    int t;
    int te;
    char dir;
};

int main()
{
    queue<int> u, l, d, r;
    int n, count = 0;
    cin >> n;
    int machine_count = n;
    struct machine mas[n];
    for(int i = 0; i < n; i++){
        cin >> mas[i].t;
        cin >> mas[i].dir;
        mas[i].te = -1;
    }
    long long i = 0;
    for(;;){
        if(!l.empty() && d.empty()){
            mas[l.back()].te = i;
            l.pop();
            if(!r.empty() && u.empty()){
                mas[r.back()].te = i;
                r.pop();
            }
        }
        if(!r.empty() && u.empty()){
            mas[r.back()].te = i;
            r.pop();
        }
        else if(!d.empty() && r.empty()){
            mas[d.back()].te = i;
            d.pop();
            if(!u.empty() && l.empty()){
                mas[u.back()].te = i;
                u.pop();
            }
        }
        if(!u.empty() && l.empty()){
            mas[u.back()].te = i;
            u.pop();
        }
        while(mas[count].t == i){
            switch(mas[count].dir){
            case 'R':
                l.push(count);
                machine_count--;
                break;
            case 'L':
                r.push(count);
                machine_count--;
                break;
            case 'U':
                d.push(count);
                machine_count--;
                break;
            case 'D':
                u.push(count);
                machine_count--;
                break;
            }
            count++;
        }
        i++;
        if(r.empty() && d.empty() && u.empty() && l.empty() && machine_count == 0) break;
        if(!r.empty() && !l.empty() && !u.empty() && !d.empty() && machine_count == 0) break;
    }
    /*for(int i = 0; i < u.size(); i++){
        mas[u.front()].te = -1;
        u.pop();
    }
    for(int i = 0; i < l.size(); i++){
        mas[l.front()].te = -1;
        l.pop();
    }
    for(int i = 0; i < r.size(); i++){
        mas[r.front()].te = -1;
        r.pop();
    }
    for(int i = 0; i < d.size(); i++){
        mas[d.front()].te = -1;
        d.pop();
    }*/
    for(int i = 0; i < n; i++){
        cout << mas[i].te <<' ';
    }
    cout << '\n';
    return 0;
}
