#include <iostream>
#include <cstdlib>
#include <cstring>
#include <algorithm>

int* step;
int** neigh;
int** numer;
int* tout;
int t;
bool* visited;

struct versh
{
	int nomer, tout;
	inline bool operator<(const versh& o)
	{
		return tout < o.tout;
	}
};

void dfs(const int& v)
{
	visited[v] = true;
	for (int i = 0; i < step[v]; ++i)
	if (visited[neigh[v][i]] == false)
		dfs(neigh[v][i]);
	tout[v] = ++t;
}

using namespace std;

int main()
{
	int n, m, i, *rx, *ry, q, j;
	bool b;
	t = 0;
	cin >> n >> m;
	step = new int[n] - 1;
	tout = new int[n] - 1;
	neigh = new int*[n] - 1;
	numer = new int*[n] - 1;
	visited = new bool[n] - 1;
	rx = new int[m];
	ry = new int[m];
	for (i = 1; i <= n; ++i)
	{
		step[i] = 0;
		visited[i] = false;
	}
	for (i = 0; i < m; ++i)
	{
		cin >> rx[i] >> ry[i];
		++step[rx[i]];
	}
	for (i = 1; i <= n; ++i)
	{
		neigh[i] = new int[step[i]];
		numer[i] = new int[step[i]];
		step[i] = 0;
	}
	for (i = 0; i < m; ++i)
	{
		neigh[rx[i]][step[rx[i]]] = ry[i];
		numer[rx[i]][step[rx[i]]] = i;
		++step[rx[i]];
	}
	for (i = 1; i <= n; ++i)
	if (visited[i] == false)
		dfs(i);
	versh* u;
	u = new versh[n];
	for (i = 0; i < n; ++i)
	{
		u[i].nomer = i + 1;
		u[i].tout = tout[i + 1];
	}
	sort(u, u + n);
	q = -1;
	b = true;
	for (i = 1; b && (i < n); ++i)
	{
		b = false;
		for (j = 0; ((!b) && (j < step[u[i].nomer])); ++j)
		{
			if (neigh[u[i].nomer][j] == u[i - 1].nomer)
				b = true;
		}
		if (b)
		{
			--j;
			if (q < numer[u[i].nomer][j])
				q = numer[u[i].nomer][j];
		}
	}
	if (b)
		cout << q + 1 << endl;
	else
		cout << -1 << endl;
	system("pause");
	return 0;
}

/*
5 5
5 1
3 2
2 4
4 5
3 5

4 4
4 2
2 3
2 3
3 1

*/
