import java.awt.Frame;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {
	String fileName = "i";
	
	int min(int a, int b, int c, int d) {
		return Math.min(Math.min(Math.min(a, b), c), d);
	}
	
	public void solve() throws IOException {

		int INF = Integer.MAX_VALUE;
		int n = nextInt();
		int[] ans = new int[n];
		int[] r = new int[n + 1];
		int[] u = new int[n + 1];
		int[] l = new int[n + 1];
		int[] d = new int[n + 1];
		int[] rq = new int[n + 1];
		int[] uq = new int[n + 1];
		int[] lq = new int[n + 1];
		int[] dq = new int[n + 1];
		Arrays.fill(r, INF);
		Arrays.fill(u, INF);
		Arrays.fill(l, INF);
		Arrays.fill(d, INF);
		Arrays.fill(ans, -1);
		Arrays.fill(rq, -1);
		Arrays.fill(uq, -1);
		Arrays.fill(lq, -1);
		Arrays.fill(dq, -1);
		
		int rn = 0, un = 0, ln = 0, dn = 0;
		for (int i = 0; i < n; i++) {
			int t = nextInt();
			String dir = nextToken();
			if (dir.equals("R")) {
				r[rn] = t;
				rq[rn] = i;
				rn++;
			} else if (dir.equals("U")) {
				u[un] = t;
				uq[un] = i;
				un++;
			} else if (dir.equals("L")) {
				l[ln] = t;
				lq[ln] = i;
				ln++;
			} else {
				d[dn] = t;
				dq[dn] = i;
				dn++;
			}
		}
		
		int ri = 0, ui = 0, li = 0, di = 0;
		int t = 0;
		zzz : while (!(r[ri] == INF && u[ui] == INF && l[li] == INF && d[di] == INF)) {
			r[ri] = Math.max(r[ri], t);
			u[ui] = Math.max(u[ui], t);
			l[li] = Math.max(l[li], t);
			d[di] = Math.max(d[di], t);
			int w = r[ri];
			int x = u[ui];
			int y = l[li];
			int z = d[di];
			
			t = min(r[ri], u[ui], l[li], d[di]);
			
			if (w == t && x == t && y == t && z == t) {
				break zzz;
			} else if (w != t && x == t && y == t && z == t) {
				ans[dq[di]] = t;
				di++;
			} else if (w == t && x != t && y == t && z == t) {
				ans[rq[ri]] = t;
				ri++;
			} else if (w == t && x == t && y != t && z == t) {
				ans[uq[ui]] = t;
				ui++;
			} else if (w == t && x == t && y == t && z != t) {
				ans[lq[li]] = t;
				li++;
			} else if (w != t && x != t && y == t && z == t) {
				ans[dq[di]] = t;
				di++;
			} else if (w != t && x == t && y != t && z == t) {
				ans[dq[di]] = t;
				di++;
				ans[uq[ui]] = t;
				ui++;
			} else if (w != t && x == t && y == t && z != t) {
				ans[lq[li]] = t;
				li++;
			} else if (w == t && x != t && y != t && z == t) {
				ans[rq[ri]] = t;
				ri++;
			} else if (w == t && x != t && y == t && z != t) {
				ans[rq[ri]] = t;
				ri++;
				ans[lq[li]] = t;
				li++;
			} else if (w == t && x == t && y != t && z != t) {
				ans[uq[ui]] = t;
				ui++;
			} else if (w != t && x != t && y != t && z == t) {
				ans[dq[di]] = t;
				di++;
			} else if (w != t && x != t && y == t && z != t) {
				ans[lq[li]] = t;
				li++;
			} else if (w != t && x == t && y != t && z != t) {
				ans[uq[ui]] = t;
				ui++;
			} else if (w == t && x != t && y != t && z != t) {
				ans[rq[ri]] = t;
				ri++;
			}
			t++;
		}

		for (int i = 0; i < n; i++) {
			System.out.println(ans[i]);
		}
		
		
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader(fileName + ".in"));
//			 out = new PrintWriter(fileName + ".out");

			solve();

//			 out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new B().run();
	}

}
