#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>
#include <set>

using namespace std;

const int N = 100010;

int n, m;
vector<int> a[N];
int mas[N];
vector<int> s;
bool was[N];
vector<pair<int, int>> gr;
set<pair<int, int>> ol;

void dfs (int v)
{
    was[v] = true;
    for (int i = 0; i < a[v].size(); i++) {
        if (!was[a[v][i]]) {
            dfs(a[v][i]);
        }
    }
    s.push_back(v);
}

int main()
{
    cin >> n >> m;
    int x, y;
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
        gr.push_back(make_pair(x - 1, y - 1));
        a[x - 1].push_back(y - 1);
        ol.insert(make_pair(x - 1, y - 1));
    }
    for (int i = 0; i < n; i++) {
        if (!was[i])
            dfs(i);
    }
    /*if (s.size() < n) {
        cout << -1 << endl;
        for (int i = 0; i < s.size(); i++) {
            cout << s[i] << ' ';
        }
        return 0;
    }*/
    reverse(s.begin(), s.end());
    /*for (int i = 0; i < s.size(); i++) {
        cout << s[i] << ' ';
    }*/
    //cout << endl << "AA" << endl;
    bool t = false;
    for (int i = 0; i < n - 1; i++) {
        if (ol.find(make_pair(s[i], s[i + 1])) == ol.end())
            t = true;
    }
    if (t) {
        cout << -1 << endl;
        return 0;
    }
    for (int i = 0; i < n - 1; i++) {
        mas[s[i]] = s[i + 1];
    }
    int ans = -1;
    bool b = false;
    for (int i = m - 1; i >= 0; i--) {
        if (mas[gr[i].first] == gr[i].second && !b) {
            ans = i + 1;
            b = true;
        }
    }
    /*for (int i = 0; i < n; i++) {
        cout << mas[i] << ' ';
    }*/
    //cout << endl;
    cout << ans << endl;
    return 0;
}
