#include <bits/stdc++.h>

using namespace std;

vector< pair<int, int> > g[100001];
vector<int> used, top;

int dfs(int v)
{
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i].first;
        if (used[u] == 0)
            dfs(u);
    }
    top.push_back(v);
    return 0;
}

int main()
{
    int n, m;
    cin >> n >> m;
    used.resize(n + 1, 0);
    for (int i = 0; i < m; i++)
    {
        int k, l;
        cin >> k >> l;
        g[k].push_back(make_pair(l, i + 1));
    }
    for (int i = 1; i <= n; i++)
        if (used[i] == 0)
            dfs(i);
    int ans = -1;
    for (int i = 1; i < top.size(); i++)
    {
        int v = top[i];
        int u = top[i - 1];
        bool ok = false;
        for (int j = 0; j < g[v].size(); j++)
        {
            if (g[v][j].first == u)
            {
                ok = true;
                ans = max(ans, g[v][j].second);
            }
        }
        if (!ok)
        {
            cout << -1;
            return 0;
        }
    }
    cout << ans;
    return 0;
}
