#include <iostream>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

vector<vector<int> > g;
vector<int> dp;

void dfs(int u)
{
    dp[u] = 1;
    for (int v : g[u])
    {
        if (dp[v] == -1)
            dfs(v);
        dp[u] = max(dp[u], dp[v] + 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int a[m][2];
    for (int i = 0; i < m; i++)
        cin >> a[i][0] >> a[i][1];
    int l = 0, r = m + 1, mid;
    while (r - l > 1)
    {
        mid = (l + r) / 2;
        g.assign(n, vector<int> ());
        dp.assign(n, -1);
        for (int i = 0; i < mid; i++)
            g[a[i][0] - 1].push_back(a[i][1] - 1);
        for (int i = 0; i < n; i++)
            if (dp[i] == -1)
                dfs(i);
        int cnt = 0;
        for (int i = 0; i < n; i++)
            cnt = max(cnt, dp[i]);
        if (cnt == n)
            r = mid;
        else
            l = mid;
    }
    cout << (r <= m ? r : -1);
    return 0;
}
