import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.*;
import java.io.*;

public class I1 {
	
	FastScanner in;
	PrintWriter out;

	static int a[][];
	static boolean vis[];
	static int m;
	static int n;
	static ArrayList<Integer> t;

	public void solve() {
		n = in.nextInt();
		m = in.nextInt();
		a = new int[m][2];
		for (int i = 0; i < m; i++) {
			a[i][0] = in.nextInt() - 1;
			a[i][1] = in.nextInt() - 1;
		}

		int l = 0;
		int r = m + 1;
		while (r - l > 1) {
			int x = (r + l) / 2;
			if (isConn(x)) {
				r = x;
			} else {
				l = x;
			}
		}
		if (m < n - 1) {
			out.println(-1);
			return;
		}
		if ((l < m+1)&&isConn(l)) {
			out.println(l);
			return;
		}
		if ((r < m+1)&&isConn(r)) {
			out.println(r);
			return;
		}

		out.println(-1);
		
	}

	public static boolean isConn(int x) {
		ArrayList<Integer> g[] = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			g[i] = new ArrayList<Integer>();
		}
		boolean p[] = new boolean[n];
		for (int i = 0; i < x; i++) {
			g[a[i][0]].add(a[i][1]);
			p[a[i][1]] = true;
		}

		vis = new boolean[n];
		t = new ArrayList<Integer>();

		for (int i = 0; i < n; i++) {
			if (!p[i]) {
				dfs(g, i);
				break;
			}
		}

		Collections.reverse(t);
		if (t.size() < n)
			return false;
		for (int i = 0; i < n - 1; i++) {
			if (!g[t.get(i)].contains(t.get(i + 1)))
				return false;
		}
		return true;
	}

	public static void dfs(ArrayList<Integer>[] g, int x) {
		vis[x] = true;
		for (int i = 0; i < g[x].size(); i++) {
			if (!vis[g[x].get(i)]) {
				dfs(g, g[x].get(i));
			}
		}
		t.add(x);
	}
	
	
	public void run() {
		in = new FastScanner (new BufferedReader(new InputStreamReader(System.in)));
		out = new PrintWriter (new BufferedWriter (new OutputStreamWriter(System.out)));
		
		solve();
		
		out.close();
	}
	
	class FastScanner {
		BufferedReader br;
		StringTokenizer st;
		
		FastScanner (BufferedReader bufferedreader) {
			br = new BufferedReader (new InputStreamReader(System.in));
		}
		
		String next() {
			while (st == null ||!st.hasMoreTokens()){
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
	}
	
	public static void main (String[] args) {
        Locale.setDefault(Locale.US);
        new I1().run();
	}
}


