#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
	int n, k;
	cin >> n >> k;
	vector<long long> s(n);
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	sort(s.begin(), s.end());

	vector<long long> dp(n + 1, LLONG_MAX);
	dp[0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			dp[j + 1] = min(dp[j + 1], dp[i] + (s[j] - (i == 0 ? 0 : s[i - 1]) + k) * (n - i));
		}
	}

	cout << dp[n] << endl;

	system("pause");

	return 0;
}