#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 320;

char arr1[maxN][maxN];
char arr2[maxN][maxN];

int min1[maxN];
int max2[maxN];

int solve(int dx, int n1, int m1, int n2, int m2)
{
    int dy = 1e9;
    for(int x = 0; x < m1; x++)
    {
        int x2 = x + dx;
        if(x2 < 0 || x2 >= m2) continue;
        if(min1[x] == -1 || max2[x2] == -1) continue;

        //cout << x << " " << min1[x] << " " << max2[x2] << endl;

        int ldy = max2[x2] - min1[x] - 1;
        dy = min(dy, ldy);
    }
    //cout << endl;
    if(dy == (int)1e9) return 0;

    //cout << dy << endl;

    int ans = 0;
    for(int y = 0; y < n1; y++)
    {
        for(int x = 0; x < m1; x++)
        {
            if(arr1[y][x] == '.') continue;

            int x2 = x + dx, y2 = y + dy;

            if(x2 <= 0) continue;
            if(y2 < 0) continue;
            if(x2 > m2) continue;
            if(y2 >= n2) continue;

            if(arr2[y2][x2-1] != '.')
            {
                ans++;
            }
        }
    }

    return ans;
}

int main()
{
    //freopen("in.in", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n1, m1, n2, m2;

    cin >> n1 >> m1;
    for(int i = 0; i < n1; i++) cin >> arr1[i];

    cin >> n2 >> m2;
    for(int i = 0; i < n2; i++) cin >> arr2[i];

    for(int x = 0; x < m1; x++) min1[x] = -1;
    for(int x = 0; x < m2; x++) max2[x] = -1;

    for(int y = 0; y < n1; y++)
    {
        for(int x = 0; x < m1; x++)
        {
            //cout << arr1[y][x];
            if(arr1[y][x] != '.') min1[x] = y;
        }
        //cout << endl;
    }


    for(int y = n2 - 1; y >= 0; y--)
    {
        for(int x = 0; x < m2; x++)
        {
            if(arr2[y][x] != '.') max2[x] = y;
        }
    }

    int ans = 0;

    for(int dx = -305; dx <= 305; dx++) ans = max(ans, solve(dx, n1, m1, n2, m2));
    cout << ans << endl;




    return 0;
}
