import java.io.*;
import java.util.*;

public class SolveB {
	
	
	int[] ans;
    public void solve() throws IOException {
        int n = nextInt();
        ans = new int[n];
        int[] t = new int[n];
        int[]d = new int[n];
        for (int i = 0; i < n; i++) {
        	t[i] = nextInt();
        	char c = nextToken().charAt(0);
        	if (c == 'U') {
        		d[i] = 0;
        	} else if (c == 'L') {
        		d[i] = 1;
        	} else if (c == 'D') {
        		d[i] = 2;
        	} else {
        		d[i] = 3;
        	}
        }
        LinkedList<Integer>[] q = new LinkedList[4];
        for (int i = 0; i < 4; i++) {
        	q[i] = new LinkedList<Integer>();
        }
        for (int i = 0; i < n; i++) {
        	q[d[i]].add(i);
        	int time = t[i];
        	int nextT = (i < n - 1) ? t[i + 1] : Integer.MAX_VALUE;
        	while (!stacked(q) && ! empty(q) && time < nextT) {
        		move(q, time);
        		time++;
        	}
        }
        for (int i = 0; i < 4; i++) {
        	for (int x : q[i]) {
        		ans[x] = -1;
        	}
        }
        for (int i = 0; i < n; i++) {
        	out.println(ans[i]);
        }
    }
    void move(LinkedList<Integer>[] q, int time) {
    	TreeSet<Integer> toMove = new TreeSet<>();
    	for (int i = 0; i < 4; i++) {
    		int right = (i + 1) % 4;
    		if (q[right].isEmpty()) {
    			toMove.add(i);
    		}
    	}
    	for (int x : toMove) {
    		if (q[x].isEmpty()) {
    			continue;
    		}
    		int leaver = q[x].removeFirst();
    		ans[leaver] = time;
    		
    	}
    }
    boolean empty(LinkedList<Integer>[] q) {
    	boolean f = true;
    	for (int i = 0; i < q.length; i++) {
			if (q[i].size() != 0) {
				f = false;
				break;
			}
		}
    	return f;
    }
    boolean stacked(LinkedList<Integer>[] q) {
    	boolean f = true;
    	for (int i = 0; i < q.length; i++) {
			if (q[i].size() == 0) {
				f = false;
				break;
			}
		}
    	return f;
    }
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new SolveB().run();
    }

}
