import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class K {
    public void solve() throws IOException {
    	int[] ps = new int[32];
    	int[] cs = new int[32];
    	int m = 1000000007;
    	ps[0] = 1;
    	for (int i = 1; i < ps.length; i++) {
			ps[i] = ps[i - 1] * 2 % m;
		}
    	int k = nextInt() + 1;
    	for (int i = 0; i < cs.length; i++) {
    		cs[i] = k / (ps[i] * 2) * ps[i] + Math.max(0, k % (ps[i] * 2) - ps[i]);
    		cs[i] = (int) (((long) cs[i]) * (k - cs[i] - 1) % m);
    	}
    	int a = 0;
    	for (int i = 0; i < cs.length; i++) {
			a += ((long) ps[i]) * cs[i] % m;
			a %= m;
		}
    	out.print(a);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new K().run();
    }

}
