#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>
#include <set>
#include <string>

using namespace std;
const int p = 239;
const int M = 1000000007;
long long h1[5002], h2[5002], pow1[5002];

get_h1(int i, int j){
    return ((h1[j + 1] - h1[i] * pow1[j - i + 1]) % M + M) % M;}

get_h2(int i, int j){
    return ((h2[j + 1] - h2[i] * pow1[j - i + 1]) % M + M) % M;}

int main()
{
    int n;
    cin >> n;
    string s1, s2;
    cin >> s1 >> s2;
    h1[0] = 0;
    h2[0] = 0;
    pow1[0] = 1;
    for(int i = 1; i < n; i++)
        pow1[i] = (pow1[i - 1] * p) % M;
    for(int i = 1; i < n + 1; i++)
    {
        h1[i] = (h1[i - 1] * p + (s1[i - 1] - 'a') + 1) % M;
        h2[i] = (h2[i - 1] * p + (s2[i - 1] - 'a') + 1) % M;
    }
    int dp[5002];
    dp[0] = 1;
    for (int i = 1; i < n + 1; i++)
    {
        dp[i] = 0;
        int x = i - 1;
        int y = n - i;
        for(int j = 0 ; j <= x ; j++)
            if ((get_h1(x - j, x) == get_h2(y, y + j)) && dp[i - j - 1] == 1)
                dp[i] = 1;
    }
    //cout << get_h1(0, 2) << " " << get_h2(8, 10);
    //for(int i = 0; i < n + 1; i++)
        //cout << dp[i] << " ";
    if (dp[n] == 1)
        cout << "Yes";
    else
        cout << "No";
    //cout << endl << s1[n];
    return 0;
}
