import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by spb on 23.10.2016.
 */

/*
11
irailikeyou
ouilikeyira

3
abc
bac
 */

public class TaskJ {
    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        String s = nextToken();
        String t = nextToken();
        if (s.equals(t)) {
            out.print("Yes");
        } else {
            int from = 0;
            int to = t.length();
            for (int i = 1; i <= n; i++) {
                String s1 = s.substring(from, i);
                String s2 = t.substring(t.length() - i, to);
                if (s1.equals(s2)) {
                    from = i;
                    to = t.length() - i;
                }
            }

            if (from == n && to == 0) {
                out.print("Yes");
            } else {
                out.print("No");
            }
        }
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out, true);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskJ().run();
    }
}
