#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
const int MAXN = 1e6;
int n, m;

vector<vector<int> > gr;
vector<pair<int, int> > hh;
vector<bool> vis;
int used[MAXN];

int dfs(int v) {
    vis[v] = 1;
    int ans = 1;
    bool flag = 0;
    for (int u : gr[v]) {
        if (!vis[u]) {
            --used[u];
            if (used[u] == 0) {
                if (!flag) {
                    ans += dfs(u);
                    flag = 1;
                }
                else {
                    return -1;
                }
            }
        }
    }
    return ans;
}

bool solve(int a) {
    gr.clear();
    gr.resize(n);
    vis.resize(n);
    fill(vis.begin(), vis.end(), 0);
    fill(used, used + n, 0);
    for (int i = 0; i < a; ++i) {
        gr[hh[i].f].pb(hh[i].s);
        used[hh[i].s] += 1;
    }
    int ctr = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            //cerr << i << " " << dfs(i) << endl;
            return dfs(i) == n;
        }
    }
    return 0;
}

int bins() {
    int st = 1;
    int fin = m;
    int rr;
    while (true) {
        if (st > fin) return -1;
        rr = (fin + st) / 2;
        //cerr << rr << endl;

        if (solve(rr)) {
            if (!solve(rr - 1)) {
                return rr;
            }
            else {
                fin = rr - 1;
            }
        }
        else {
            st = rr + 1;
        }
    }
}
int main(){
    scanf("%d%d", &n, &m);
    hh.resize(m);
    gr.resize(n);
    int p, q;
    for (int i = 0; i < m; ++i) {
        scanf("%d%d", &p, &q);
        --p; --q;
        hh[i] = mp(p, q);
    }
    cout << bins();
}
/*
5 5
5 1
3 2
2 4
4 5
3 5
*/
